#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "kohn_gif.h"

#define WIDTH 352
#define HEIGHT 240

void read_bmp(char *filename, unsigned char *buffer)
{
FILE *in;
int r;

  in=fopen(filename,"rb");
  if (in==0) return;

  fseek(in,10,SEEK_SET);
  r=getc(in)+(getc(in)<<8);
  fseek(in,r,SEEK_SET);

  for (r=0; r<WIDTH*HEIGHT; r++)
  {
    buffer[r]=(getc(in)+getc(in)+getc(in))/3;
  }

  fclose(in);
}

void draw_black(unsigned char *puzzle_buffer, int square_num)
{
int ptr;
int y;

  ptr=((square_num/5)*(WIDTH*(HEIGHT/5)))+((square_num%5)*(WIDTH/5));

  for (y=0; y<HEIGHT/5; y++)
  {
    memset(puzzle_buffer+ptr,0,WIDTH/5);
    ptr=ptr+WIDTH;
  }

}

void draw_piece(unsigned char *puzzle_buffer, int square_num, unsigned char *bmp_buffer, int piece_num)
{
int ptr,bptr;
int y;

  // piece_num=(4-piece_num)+1;
  // piece_num++;
  ptr=((square_num/5)*(WIDTH*(HEIGHT/5)))+((square_num%5)*(WIDTH/5));
  bptr=((5-(piece_num/5))*(WIDTH*(HEIGHT/5)))+((piece_num%5)*(WIDTH/5));

  for (y=0; y<HEIGHT/5; y++)
  {
    bptr=bptr-WIDTH;
    memcpy(puzzle_buffer+ptr,bmp_buffer+bptr,WIDTH/5);
    ptr=ptr+WIDTH;
  }

}


int main(int argc, char *argv[])
{
unsigned char bmp_buffer[WIDTH*HEIGHT];
unsigned char puzzle_buffer[WIDTH*HEIGHT];
struct gif_info_t *output_gif;
char *querystring;
int piece_num,t;

  querystring=getenv("QUERY_STRING");

  printf("Content-Type: image/gif\r\n\r\n");

  read_bmp("/var/www/localhost/cgi-bin/narc_apple4.bmp",bmp_buffer);

  output_gif=kgif_alloc_compress();
  output_gif->fp=stdout;

  output_gif->width=WIDTH;
  output_gif->height=HEIGHT;
  output_gif->colors=256;

  for (t=0; t<256; t++) output_gif->color_map[t]=(t<<16)+(t<<8)+t;

  for (t=0; t<25; t++)
  {
    if (querystring[t]==0) break;
    piece_num=querystring[t]-'a';
    if (piece_num<0 || piece_num>=25) continue;

    if (piece_num==0)
    { draw_black(puzzle_buffer,t); }
      else
    { draw_piece(puzzle_buffer,t,bmp_buffer,piece_num); }
  }

  kgif_write_header(output_gif);
  kgif_compress_block(output_gif,puzzle_buffer,WIDTH*HEIGHT);

  kgif_write_footer(output_gif);
  kgif_info_free(output_gif);

  return 0;
}

